{$A+,B-,F+,G+,N+,P+,Q-,R-,T-,V+,X+}
{****************************************************************************
 * Global unit for GX2 - copyright (c) 1998-2000 by Stefan Goehler          *
 * License agreement in gx2.txt - illegal copy without this file!           *
 * Complete package and new version always available here:                  *
 * http://sourcenet.home.pages.de                                           *
 ****************************************************************************}
{$IFNDEF DPMI}
  !Real mode not supported!
  This unit is fully 32 bit oriented, so forget about real mode.
  You need BP7 to use protected mode. If you have it, please
  switch at compiler/platform to PM (start bp.exe!)
{$ENDIF}
{$IFOPT I+}
{$DEFINE NOCHECK}
{$ENDIF}
unit gx_glob;
interface
uses newfrontier,stream32;

  procedure  swaplong(var i1,i2);
  procedure  swapint(var i1,i2);
  procedure  swapshort(var i1,i2);

  procedure  swapendian32(var i);
  procedure  swapendian16(var i);

  procedure  pageretrace;
  procedure  waitretrace;

  function   inttostr(l : longint) : string;
  function   flttostr(l : double;f1,f2 : byte) : string;
  function   hexstr(l : longint;width : word) : string;
  function   hextoint(s : string) : longint;
  function   strtoint(s : string) : longint;
  function   getbit(value,bit : byte) : boolean;

  function   GetRMSelector(segment : word) : word;
  procedure  textscreen_get;
  procedure  textscreen_put;
  procedure  textscreen_discard;

  procedure  calc_circle(pointarray : pointer48;r : word);
  procedure  calc_ellipse(pointarray : pointer48;rx,ry : word);
{  function   getcpuid : longint;}
  procedure  randarray_byte(dataarray : pointer48;count,range : longint);
  procedure  randarray_word(dataarray : pointer48;count,range : longint);
  function   testmmx  : boolean;
  function   test3dnow : boolean;
  { Don't call directly following procedures if you don't know how to use }
  { them                                                                  }
  procedure  fillpatt_8(dest : pointer48;count,value : longint;xpos : byte;pattern : byte);
  procedure  fillpatt_1516(dest : pointer48;count,value : longint;xpos : byte;pattern : byte);
  procedure  fillpatt_24(dest : pointer48;count,value : longint;xpos : byte;pattern : byte);
  procedure  fillpatt_32(dest : pointer48;count,value : longint;xpos : byte;pattern : byte);
  procedure  fillxor_1516_386(dest : pointer48;count,data : longint);
  procedure  fillxor_1516_mmx(dest : pointer48;count,data : longint);
  procedure  fillxor_24_386(dest : pointer48;count,data : longint);
  procedure  fillxor_32_386(dest : pointer48;count,data : longint);
  procedure  fillxor_32_mmx(dest : pointer48;count,data : longint);
  procedure  pattxor_1516(dest : pointer48;count,value : longint;xpos : byte;pattern : byte);
  procedure  pattxor_24_386(dest : pointer48;count,value : longint;xpos : byte;pattern : byte);
  procedure  pattxor_32_386(dest : pointer48;count,value : longint;xpos : byte;pattern : byte);
  procedure  pattxor_32_mmx(dest : pointer48;count,value : longint;xpos : byte;pattern : byte);
  procedure  pattadd_15(dest : pointer48;count,value : longint;xpos : byte;pattern : byte);
  procedure  pattadd_16(dest : pointer48;count,value : longint;xpos : byte;pattern : byte);
  procedure  pattadd_24_386(dest : pointer48;count,value : longint;xpos : byte;pattern : byte);
  procedure  pattadd_32_386(dest : pointer48;count,value : longint;xpos : byte;pattern : byte);
  procedure  pattadd_32_mmx(dest : pointer48;count,value : longint;xpos : byte;pattern : byte);
  procedure  pattsub_15(dest : pointer48;count,value : longint;xpos : byte;pattern : byte);
  procedure  pattsub_16(dest : pointer48;count,value : longint;xpos : byte;pattern : byte);
  procedure  pattsub_24_386(dest : pointer48;count,value : longint;xpos : byte;pattern : byte);
  procedure  pattsub_32_386(dest : pointer48;count,value : longint;xpos : byte;pattern : byte);
  procedure  pattsub_32_mmx(dest : pointer48;count,value : longint;xpos : byte;pattern : byte);
  procedure  addfill_15(dest : pointer48;count,data : longint);
  procedure  addfill_16(dest : pointer48;count,data : longint);
  procedure  addfill_24_386(dest : pointer48;count,data : longint);
  procedure  addfill_32_386(dest : pointer48;count : longint;data : longint);
  procedure  addfill_32_mmx(dest : pointer48;count : longint;data : longint);
  procedure  subfill_15(dest : pointer48;count,data : longint);
  procedure  subfill_16(dest : pointer48;count,data : longint);
  procedure  subfill_24_386(dest : pointer48;count,data : longint);
  procedure  subfill_32_386(dest : pointer48;count,data : longint);
  procedure  subfill_32_mmx(dest : pointer48;count,data : longint);
  procedure  move2_386(input,output : pointer48;count : longint);
  procedure  move2_mmx(input,output : pointer48;count : longint);
  procedure  backmove2_386(input,output : pointer48;count : longint);
  procedure  backmove2_mmx(input,output : pointer48;count : longint);
  procedure  move2screen_386(input,output : pointer48;count : longint);
  procedure  move2screen_mmx(input,output : pointer48;count : longint);
  procedure  movemul2screen_386(input,output : pointer48;count,sbpl,dbpl,ylines : longint);
  procedure  movemul2screen_mmx(input,output : pointer48;count,sbpl,dbpl,ylines : longint);
  procedure  movefromscreen_386(input,output : pointer48;count : longint);
  procedure  movefromscreen_mmx(input,output : pointer48;count : longint);
  procedure  fillbyte_386 (dest : pointer48;count,data : longint);
  procedure  fillword_386 (dest : pointer48;count,data : longint);
  procedure  fillword_mmx (dest : pointer48;count,data : longint);
  procedure  fill24_386   (dest : pointer48;count,data : longint);
  procedure  filldword_386(dest : pointer48;count,data : longint);
  procedure  filldword_mmx(dest : pointer48;count,data : longint);
  procedure  xor2screen_386(input,output : pointer48;count : longint);
  procedure  xor2screen_mmx(input,output : pointer48;count : longint);
  procedure  and2screen_386(input,output : pointer48;count : longint);
  procedure  and2screen_mmx(input,output : pointer48;count : longint);
  procedure  or2screen_386(input,output : pointer48;count : longint);
  procedure  or2screen_mmx(input,output : pointer48;count : longint);

const
{ Screen moving procedures }

  move2screen   : procedure(input,output : pointer48;count : longint) = move2screen_386;
  movefromscreen: procedure(input,output : pointer48;count : longint) = movefromscreen_386;
  movemul2screen: procedure(input,output : pointer48;count,sbpl,dbpl,ylines : longint) = movemul2screen_386;
  xor2screen    : procedure(input,output : pointer48;count : longint) = xor2screen_386;
  and2screen    : procedure(input,output : pointer48;count : longint) = and2screen_386;
  or2screen     : procedure(input,output : pointer48;count : longint) = or2screen_386;

{ Memory moving procedures }

  move2         : procedure(input,output : pointer48;count : longint) = move2_386;
  backmove2     : procedure(input,output : pointer48;count : longint) = move2_386;

{ Manipulating procedures }

  addfill_32    : procedure(dest : pointer48;count,data : longint) = addfill_32_386;
  subfill_32    : procedure(dest : pointer48;count,data : longint) = subfill_32_386;
  fillxor_1516  : procedure(dest : pointer48;count,data : longint) = fillxor_1516_386;
  fillxor_32    : procedure(dest : pointer48;count,data : longint) = fillxor_32_386;
  pattadd_32    : procedure(dest : pointer48;count,value : longint;xpos : byte;pattern : byte) = pattadd_32_386;
  pattsub_32    : procedure(dest : pointer48;count,value : longint;xpos : byte;pattern : byte) = pattsub_32_386;
  pattxor_32    : procedure(dest : pointer48;count,value : longint;xpos : byte;pattern : byte) = pattxor_32_386;

{ Mem filling procedures }

  fillbyte : procedure(dest : pointer48;count,data : longint) = fillbyte_386;
  fillword : procedure(dest : pointer48;count,data : longint) = fillword_386;
  fill24   : procedure(dest : pointer48;count,data : longint) = fill24_386;
  filldword: procedure(dest : pointer48;count,data : longint) = filldword_386;

{ Screen filling procedures }

  fill8screen  : procedure(dest : pointer48;count,data : longint) = fillbyte_386;
  fill16screen : procedure(dest : pointer48;count,data : longint) = fillword_386;
  fill24screen : procedure(dest : pointer48;count,data : longint) = fill24_386;
  fill32screen : procedure(dest : pointer48;count,data : longint) = filldword_386;

{ Output device dvXXXX constants }

  dvscreen    = $01; { device is the graphiccard                   }
  dvmemory    = $02; { device is the memory                        }
  dvwindow    = $04; { device is a window on the card or in memory }

{ Initgfx mdXXXX flags }

  mdauto      = $00; { Initgfx decides itself the best             }
  mdbanked    = $01; { Prefer banked mode                          }
  mdnoaccel   = $02; { Prefer no hardware acceleration             }
  mdbestfit   = $04; { Find best fitting video mode for resx:resy  }

{ tmode.flags mdXXXX }

  mdlinear    = $01; { Current mode is a linear accessed mode      }
  mdtwowin    = $02; { Seperated read/write windows                }
  mdgreyscale = $04; { Mode is greyscaled                          }

{ Color resolutions for automatic search in initgfx }

  clhi        = $81; { Prefers 16 bit, uses also 15 bit            }
  cltrue      = $82; { Prefers 32 bit, uses also 24 bit            }
  clhitrue    = $84; { Prefers 32 bit, uses also 24,16,15 bit      }
  clhitrueno24= $88; { Prefers 32 bit, uses also 16,15 bit, not 24 }

{ GFX Card gdXXXX capabilities }

  { cinterface  }
  gdbanked    = $00000001; { Card can handle banked modes         }
  gdlinear    = $00000002; { Card is able to get accessed linear  }
  gdsetoffset = $00000004; { X/Y-Offset can be changed            }
  gdvwidth    = $00000008; { virtual x-resolution can be changed  }
  gdrate      = $00000010; { Card allows to change refresh rate   }
  gdclear     = $00000020; { Driver supports clearscreen in hw    }
  gddac8bit   = $00000040; { In 8 bit mode, dac can be switched from 6 to 8 bits }
  gdsavestate = $00000080; { Hardware registers can be saved/restored }

  { cclipping   }
  gdcliprect  = $00000001; { Card is able to clip in rectangles   }

  { cbitmapping }
  gdscale     = $00000001; { Card can scale images itself         }
  gdblit      = $00000002; { Card accelerates bitblitting         }
  gdyuv2rgb   = $00000004; { Card supports yuv to rgb conversion  }
  gdalphamap  = $00000008; { Card supports images with alphamap   }

  { cprimitives }
  gdfrect     = $00000001; { Card can draw filled rectangles      }
  gdfcirlce   = $00000002; { Card can draw filled circles         }
  gdfellipse  = $00000004; { Card can draw filled ellipses        }
  gdcirlce    = $00000008; { Card can draw circles                }
  gdellpse    = $00000010; { Card can draw                        }
  gdfstyle    = $00010000; { Card is able to handle fill styles   }
  gdftransstyle= $00020000; { Card can draw transparent fill styles}
  gdfaddsub   = $00040000; { Card supports area add/sub           }
  gdfalpha    = $00080000; { Card supports area alphamapping      }
  gdlinestyle = $01000000; { Card supports line styles            }
  { cpolygons   }
  gdpoly      = $00000001; { Card draws polygons                  }

  { Setupvideo (device) error deXXXX constants }
  denoerror   = $0000;     { Device initialized successfully      }
  defail      = $0001;     { Device init failed                   }
  demdnotav   = $0002;     { Requested mode not available         }
  denosupport = $0003;     { function not supported by hardware   }
  denodrvsupp = $0004;     { function not supported by driver     }

  { tdrvinfo.bustype cdXXXX constants }
  cdbusunknown  = 0;
  cdbusisa      = 1;
  cdbuseisa     = 2;
  cdbusmca      = 3;
  cdbusvl       = 4;
  cdbuspci      = 5;
  cdbusagp      = 6;

{ Image imXXXX flags }
  { Bits 00..23 : Normal image flags, also for subimages      }
  { Bits 24..31 : Internal flags, only in global image header }
  imdefault   = $00000000;
  impalette   = $00000001; { Palette at the start of the image (size: 1K) }
  imsprite    = $00000002; { Image has transparent color, is a sprite     }
  imrle       = $00000004; { Image is RLE-compressed sprite               }
  imalpha     = $00000008; { Image contains alpha-channel                 }
  imswap      = $00000010; { Image data needs to be swapped: BGR<->RGB    }
  imgreyscale = $00000020; { Image is a greyscaled image                  }
  imcursor    = $00000100; { spotx and spoty are valid, image is cursor   }
  imlocked    = $01000000; { Closeimage must not release memory           }
  imallpal    = $02000000; { Palette is valid for all subimages           }
  immulti     = $04000000; { DATA contains more than one image            }
  imidentical = $08000000; { Subimages have same sizex:sizey and bpp      }
{ Image drawing drXXXX flags }
  { Bits 00..07 : reserved for byte-values which may be part of a command }
  { Bits 08..23 : normal draw-flags                                       }
  { Bits 24..31 : non-draw procedures with advanced options, like scale   }
  drdefault   = $00000000; { Normal behaviour of draw                     }
  dradd       = $00000100; { Add content of the image to the background   }
  drsub       = $00000200; { Subtract content of image from background    }
  drdither    = $00000400; { Dither image if conversion 32/24 to 15/16    }
  drxor       = $00000800; { Combine image with background via XOR        }
  dror        = $00001000; { Combine image with background via OR         }
  drand       = $00002000; { Combine image with background via AND        }
  { Scale flags }
  drbilinear  = $01000000; { Scale bilinear, slower                       }

{ Image loader ldXXXX flags }

  lddefault   = $00000000; { Use given bpp for loading                    }
  ldauto      = $00000001; { Ignore given bpp, use best bpp if given image}
                           { not open, otherwise use image.bpp            }
  ldalpha     = $00000002; { Ignore given bpp if image has alphachannel   }
  lddither    = drdither;
  ldhasalpha  = $01000000; { INTERNAL USAGE! Image has alphachannel       }
  ldallpal    = imallpal;
{ Image saver svXXXX flags }

  { Bits 00..07: byte values for saver specific usage, e.g. compression
                 ratio
    Bits 08..31: saving flags }
  svdefault   = $00000000;
  svinterlace = $00000100; { Save image interlaced, if supported         }
  svsmallest  = $00000200; { Save image as small as possible             }

{ Font fnXXXX flags }

  fnfixed        = $01; { Font characters have all sizex                 }
  fnmulti        = $02; { Font has got different sizes of a character    }
  fnanimate      = $04; { Font is multifont with different looking chars }
  fnanipos       = $08; { Font is position animated                      }
  fnscaleable    = $10; { Font is allowed to be scaled                   }
  fnvector       = $20; { Font is vectorized font                        }
  fnlocked       = $01000000; { Font mem deallocation not allowed        }

{ Text textXXXX constants }
  textdefault    = $00000000;

  { Text align textXXXX constants }
  textleft       = textdefault;
  textright      = $00000001;
  textcentered   = $00000002;
  texttop        = textdefault;
  textbottom     = $00000001;

  { Text flags textXXXX flags }
  textunderline    = $00000001;
  textstrikeout    = $00000002;
  textantialias    = $00000004;
  textsub          = $00000100;
  textadd          = $00000200;

{ Rectangle fillXXXX putting flags }

  filldefault    = $00000000;
  fillsub        = $01000000;
  filladd        = $02000000;
  fillxor        = $04000000;
  fillantialias  = $08000000; { Not supported at all yet }

{ Line,Circle,Ellipse lnXXXX putting flags }

  lndefault      = $00000000;
  lnantialias    = $00000001;

{ Format string constants }

  idimage        = {'GfX2'} $32586647;
  idfont         = 'Fnt2';

{ Image data conversion constants }

  cnvdefault     = $0000; { Leave normal RGB/BGR                        }
  cnvswap        = $0001; { Interchange first and last byte - BGR<->RGB }
{  cnvauto        = $0100; { Look automatically for best dithering       }
  cnvdither      = drdither; { $400; Prefer 4x4 ordered dithering        }

{ CPU extension constants }
  cpummx         = $00000001; { Detected CPU supports MMX commands    }
  cpu3dn         = $00000002; { Detected CPU supports 3DNow! commands }

  { Errxxxx Errorcodes for all GX functions  }
  { the last 4 bits state the error priority }
  errnoerror      = $0000;
  errfilenotfound = $0001;
  errfalseformat  = $1002;
  errfileerror    = $1003;
  errfalseend     = $1004;
  errnomem        = $2005;
  errnodiskmem    = $2006;
  errfalsebpp     = $1007;
  errgenerror     = $1008;
  errempty        = $1009;
  errwrongsize    = $000A;
  errtoolarge     = $100B;
  errnotopen      = $100C;
  errlocked       = $100D;
  erralloc        = $200E;
  errnodvsupport  = $100F;
  errwriteerror   = $1010;
  errdeverror     = $1011;
  errdevnotfound  = $1012;
  errnopal        = $1013;
  errsmallbuffer  = $1014;
  errrangeerror   = $1015;
{
> errTooManySprites    = $1015;
> errInvalidHandle     = $0016;
> errSpriteOnScreen    = $0017;
> errSpriteNotOnScreen = $0018;
> Ich denke mal, da ich die Prioritten richtig gesetzt habe, oder ?
Ist ok.

> Dann mu der errErrorStr-Array noch um folgende Werte erweitert werden:
> ('Too many Sprites (> 255)',
> 'Invalid Sprite Handle',
> 'Sprite is on the screen',
> 'Sprite is not on the screen');
}

  errmaxerror = 21;
  { DON'T ACCESS DIRECTLY!!! USE grafx2.geterrorstring!!! }
  errerrorstr : array[0..errmaxerror] of string[45] =
  ('No error occured',
   'File not found',
   'Format not supported',
   'File error',
   'Unexpected end of file',
   'Out of memory',
   'Disk full',
   'Color resolution not supported',
   'Generic error',
   'File doesn''t contain data',
   'Image has got wrong size',
   'Image too large',
   'Object not opened',
   'Object is memory locked',
   'Memory allocation error',
   'Function not supported by device',
   'File write error',
   'Device error',
   'Device not found',
   'Palette expected',
   'Internal data buffer too small for process',
   'Command exceeds maximum range'
   );

type
  tpoint = record
    x,y : integer;
  end;
  tviewport = record
    x1,y1,x2,y2 : longint;
  end;

  pfont = ^tfont;
  tfont = record
    id                    : array[0..3] of char;  { 'Fnt2'              }
    version               : word;                 { 0101h               }
    name                  : array[0..31] of char; { Name of the font - #0-terminated }
    copyright             : array[0..31] of char; { #0-terminated       }
    fonttype              : array[0..3] of char;  { 'BMP1','VECL'...    }
    numofsubfonts         : word;     { Number of different subfonts    }
    data                  : word;
    space                 : array[0..1] of byte;
    size                  : longint;  { Size in memory                  }
    flags                 : longint;  { See fontfmt.txt                 }

    fontstart             : longint;  { Offset of the font start        }
    bpp                   : byte;     { bits per pixel                  }
    bpl                   : word;     { BMP-fonts; bytes per line       }
    sizex,sizey           : word;     { Size of largest character       }
    baseline              : word;     { Baseline of the characters      }
    descender             : word;
    startchar,endchar     : word;     { Yea, we support more than 255!  }
    distance              : byte;     { Distance between characters     }
    randomx,randomy       : byte;     { Only <> 0 if flag anipos on     }
    usedcolors            : longint;  { Only really needed for BMP8 yet }
    spacer                : longint;  { Distance for non-existing chars }
    reserved              : array[0..9] of byte;
  end;

  psubfont = ^tsubfont;
  tsubfont = record
    fontstart             : longint;  { Offset of the font start        }
    bpp                   : byte;     { bits per pixel                  }
    bpl                   : word;     { BMP-fonts; bytes per line       }
    sizex,sizey           : word;     { Size of largest character       }
    baseline              : word;     { Baseline of the characters      }
    descender             : word;
    startchar,endchar     : word;     { Yea, we support more than 255!  }
    distance              : byte;     { Distance between characters     }
    randomx,randomy       : byte;     { Only <> 0 if flag anipos on     }
    usedcolors            : longint;  { Only really needed for BMP8 yet }
    spacer                : longint;  { Distance for non-existing chars }
    reserved              : array[0..9] of byte;
  end;
  { Type for pattern filling }
  tpattern = array[0..8] of byte; { 1st byte is 1, if solidfill, otherwise 0 }

  pmode = ^tmode;
  tmode = record
    mode              : longint; { normally vesa-screenmode       }
    maxx,maxy         : word;    { Maximum X/Y of used viewport   }
    resx,resy         : word;    { Size of area where viewport is }
    visx,visy         : word;    { For virtual screen sizes -
                                   visible pixels                 }
    lasty             : longint; { last available y-line          }
    requiredlines     : longint; { Lines required by the graphic
                                   driver for acceleration etc.   }
    requiredmem       : longint; { Required memory by the driver  }
    displayofs        : longint; { Offset of the actual page      }
    pageadd           : longint; { Y-addition for the actual page }
    actpage           : word;
    vispage           : word;
    pagesize          : longint;
    bpp               : word;    { bits per pixel                 }
    pixel             : longint; { _bytes_ per pixel              }
    bpl               : longint; { bytes per scanline             }
    flags             : longint;
    { PM LFB    }
    linearptr         : longint; { pointer to the linear window   }
    { Both      }
    writeptr,readptr  : tselector;{read/write selectors           }
    memsize           : longint; { allocated memory               }
    device            : byte;    { see device constants above     }
    numofpages        : byte;
    { Primitive settings }
    linestyle         : longint;
    pattern           : tpattern;
    { Font settings      }
    font : record
      font          : ^tfont;
      align         : tpoint;
      sizex,sizey   : double;
      angle         : double;
      flags         : longint;
      bmp8data      : tselector; { Color palette for BMP8 fonts }
    end;
    { Viewport settings - DO NOT CHANGE YOURSELF!!! }
    actviewport       : tviewport;
    calcofs           : function(x,y : integer;var mode) : longint;
    { Color data information, <= 8 bit modes }
    virtpal     : tselector; { Virtual palette     }
    rgbdata     : tselector; { Color approximation }
    palchanged  : boolean;
  end;

  { Image format used in GX2 }
  pimage = ^timage;
  timage = record
    id          : longint;             { GfX2                     }
    version     : word;                { 0100h                    }
    numofimages : word;                { e.g. animated images     }
    data        : word;                { Selector to the data     }
    space       : array[0..1] of byte; { Should be all zero       }
    { All below must be equal to tsubimage }
    sizex,sizey : longint;
    bpp         : word;                { Bits Per Pixel           }
    bpl         : longint;             { Bytes Per Line           }
    pixel       : longint;             { bytes per Pixel          }
    size        : longint;             { Allocated memory         }
    imagestart  : longint;             { start of image to show   }
    palstart    : longint;             { start of palette         }
    flags       : longint;             { See description          }
    transcol    : longint;             { Transparent color        }
    time        : word;                { if animated: time in ms how long frame should be shown }
    spotx,spoty : word;                { Needed for cursor images }
    reserved    : array[0..7] of byte; { Should be all zero       }
  end;
  psubimage = ^tsubimage;
  tsubimage = record
    sizex,sizey : longint;
    bpp         : word;                { Bits Per Pixel           }
    bpl         : longint;             { Bytes Per Line           }
    pixel       : longint;             { bytes per Pixel          }
    size        : longint;             { Allocated memory         }
    imagestart  : longint;             { start of image to show   }
    palstart    : longint;             { start of palette         }
    flags       : longint;             { See description          }
    transcol    : longint;             { Transparent color        }
    time        : word;                { if animated: time in ms how long frame should be shown }
    spotx,spoty : word;                { Needed for cursor images }
    reserved    : array[0..7] of byte; { Should be all zero       }
  end;

  pimageinfo = ^timageinfo;
  timageinfo = record
    { They MUST be ALL filled by a loader! }
    sizex,sizey  : word   ;
    bpp          : word   ;   { Bytes per pixel            }
    greyscale    : boolean;
    alphachannel : boolean;
    transparency : boolean;   { Image is transparent       }
    compressed   : boolean;
    comptype     : string[15];{ Short compression type string, i.e. 'RLE' }
    subformat    : string[15];
    interlaced   : boolean;   { Image is interlaced        }
    frames       : longint;   { only filled if video, otherwise = 1 }
    speed        : longint;   { if video, then in fps*1000, means 25 fps = 25000 }
    trans_color  : longint;   { transparent color          }
    memsize      : longint;   { size in memory when loaded }
    disksize     : longint;   { file size on disk          }
    supported    : boolean;   { true if loadable by loader }
    version      : longint;   { version of the imageformat }
  end;

  { Information type about drivers for programs }
  pdrvinfo = ^tdrvinfo;
  tdrvinfo = record
    drvname           : string[31];{ name of the driver                    }
    drvversion        : word;      { version of the driver                 }
    drvsubversion     : word;      { subversion, usually date;format: mmdd }
    drvversionstr     : string[11];{ version string of the driver          }
    drvprod           : string[51];{ producer of the driver                }
    copyright         : string[51];{ copyright information                 }
    producer,name     : string[31];{ Chipproducer and name                 }
    rev,subrev        : longint;   { revision code of the chip             }
    capabilities : record
      cinterface  : longint;
      cclipping   : longint;
      cbitmapping : longint;
      cprimitives : longint;
      cpolygons   : longint;
      reserved    : array[0..3] of longint;
    end;
    memory            : longint;
    linearaddress     : longint;
    bustype           : word; { see cdbusXXXX constants }
    priority          : byte; { priority before other drivers;vesa = 1;
                                hardware = 2; The more the higher the priority }
    reserved          : array[0..3] of longint;
  end;

  { type for graphical card drivers }
  pgfxdriver = ^tgfxdriver;
  tgfxdriver = record
    info : tdrvinfo;
    proc : record
      detect      : function : word; { Returns number of detected cards }
      fillmodetable    : procedure(var table);
      fillrefreshtable : procedure(var table);
      setupvideo  : function(modenum : longint;var mode : tmode;flags : longint) : word;
      closevideo  : procedure(var mode : tmode);
      setclip     : procedure(x1,y1,x2,y2 : longint);
      setrefresh  : function(value : word) : word;
      fillrect    : procedure(x1,y1,sizex,sizey,col,flags : longint);
      bitblit     : procedure(x1,y1,x2,y2,dx,dy : longint);
      scale       : procedure(image : timage;px,py,sx,sy,flags : longint);
      fillpoly    : procedure(points : word;var polypoints);
      clear       : procedure;
      setbank     : procedure(bank : word);
      incbank     : procedure;
      decbank     : procedure;
      setdisplaypos : procedure(x,y : word);
      setvirtualscreenwidth : function(width : word) : word;
      savestate    : function : boolean; { Save current hardware register state     }
      restorestate : function : boolean; { Restore current hardware register state  }
      switchdacto8 : function : boolean; { In 8 bit modes, switch to 8 bit DAC mode }
      reserved     : array[0..31] of longint; { future compability }
    end;
  end;

  tgfxdetproc = function(var driver : tgfxdriver) : boolean;

  pdrvregistered = ^tdrvregistered;
  tdrvregistered = record
                    driver   : pgfxdriver;
                    detected : word;
                    next     : pdrvregistered;
                  end;

  pcpuswitch = ^tcpuswitch;
  tcpuswitch = procedure(flags : longint);

  pswitchregistered = ^tswitchregistered;
  tswitchregistered = record
                    switch : pcpuswitch;
                    next   : pswitchregistered;
                  end;

  tmoderec = record
    resx,resy : word;
    mode      : longint;
  end;

  pmodetable = ^tmodetable;
  tmodetable = array[0..4] of record
    avmodes : word;
    mode : array[0..24] of tmoderec;
  end;
  { color value types }
  trgb = record case byte of
    0 : (b,g,r,d : byte);
    1 : (l : longint);
    2 : (col : array[0..3] of byte)
  end;
  tcol32 = longint;
  thsv   = record h,s,v : byte;end;
  thls   = record h,l,s : byte;end;
  tcmy   = record c,m,y : byte;end;
  tyuv   = record y,u,v : byte;end;
  tcmyk  = record c,m,y,k : byte;end;

const
  gfxbufsize    = 131072; { DON'T decrease that value, else some functions
                            may hang. Only increasing is possible, but not
                            all functions will take advantage of that.
                            Default value is 131072 bytes                  }

  { Pattern style constants }

  ptdefault    : tpattern=(1,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF);
  ptline       : tpattern=(0,$FF,$FF,$00,$00,$FF,$FF,$00,$00);
  ptliteslash  : tpattern=(0,$01,$02,$04,$08,$10,$20,$40,$80);
  ptslash      : tpattern=(0,$07,$0E,$1C,$38,$70,$E0,$C1,$83);
  ptbkslash    : tpattern=(0,$07,$83,$C1,$E0,$70,$38,$1C,$0E);
  ptltbkslash  : tpattern=(0,$5A,$2D,$96,$4B,$A5,$D2,$69,$B4);
  pthatch      : tpattern=(0,$FF,$88,$88,$88,$FF,$88,$88,$88);
  ptxhatch     : tpattern=(0,$18,$24,$42,$81,$81,$42,$24,$18);
  ptinterleave : tpattern=(0,$CC,$33,$CC,$33,$CC,$33,$CC,$33);
  ptwidedot    : tpattern=(0,$80,$00,$08,$00,$80,$00,$08,$00);
  ptclosedot   : tpattern=(0,$88,$00,$22,$00,$88,$00,$22,$00);

  { Line style constants }

  lnsdefault = $FFFFFFFF; { --------- }
  lnsdotted  = $CCCCCCCC; { ......... }
  lnscenter  = $FC78FC78; { - - - - - }
  lnsdashed  = $F8F8F8F8; { - - - - - }

  { Conversion information variables }

  cnvdrwmd : longint = cnvdefault; { Conversion mode for image drawing    }
  cnvimgmd : longint = cnvdefault; { Conversion mode for image loaders    }
  cnvvidmd : longint = cnvdefault; { Conversion mode for video players    }
  cnvxpos  : longint = 0;          { Positions are needed when converting }
  cnvypos  : longint = 0;          { an image with dithering              }

type
  pcnvproc = ^tcnvproc;
  tcnvproc = procedure(source,dest : pointer48;count : longint);

var
  { Conversion palette ptr    }

  cnvpal    : pointer48;

  { Linked fonts              }

  fnsystem    : tfont;

  { CPU extension information }

  cpuext      : longint;

  { Graphic data buffers      }

  gfxbufsel   : tselector; { Selector to the gfx buffer          }
  gfxbufptr   : pointer48; { Simple pointer instead of selector, }
                           { offset MUST be zero                 }
  gfxbufptr32 : pointer;   { 32 bit Pointer to buffer            }


  { Driver variables          }

  registeredgfxdrivers : word; { Number of registered drivers          }
  workinggfxdrivers    : word; { Number of drivers which detected card }

  lastdrv    : tdrvregistered;
  lastswitch : tswitchregistered;
  restab     : tmodetable;

  { variables for bankswitching }

  lastbank  : word; { Last bank switched to         }
  actdrv    : pgfxdriver;

  incbank : procedure;
  decbank : procedure;
  setbank : procedure(bank : word);

  { variables for getting/putting last textscreen }

  textscreen : record
    data    : pointer;
    grabbed : boolean;
    cpos    : tpoint;
    size    : word;
    mode    : word;
  end;

  { GX2 error function text output }

  gxerror : text;


  function   getcurrentdriverinfo(var info : tdrvinfo) : boolean;
  function   getdriverinfo(drivernum : longint;var info : tdrvinfo) : boolean;
  function   registergfxdriver(driver : pgfxdriver) : boolean;
  procedure  modetable_sort(table : pmodetable);
  function   modetable_mdauto(resx,resy : word;bpp : word;table : pmodetable) : longint;
  function   modetable_mdbestfit(resx,resy : word;bpp : word;table : pmodetable) : longint;
  function   registercpuswitch(switch : pcpuswitch) : boolean;
  function   setcpuext(flags : longint) : boolean;
  function   loadfont(var stream : tstream32;var font : tfont) : word;
{  function   loadfontmem(p : pointer48;var font : tfont) : word;}
  function   savefont(var stream : tstream32;var font : tfont) : word;
  function   closefont(var font : tfont) : word;

  procedure  sysfont2;

implementation

{$L sysfont2}
procedure sysfont2;external;

{$L grafx2}
{function   getcpuid;external;}
function   testmmx;external;
function   test3dnow;external;
procedure  move2_386;external;
procedure  move2_mmx;external;
procedure  backmove2_386;external;
procedure  backmove2_mmx;external;
procedure  move2screen_386;external;
procedure  move2screen_mmx;external;
procedure  movemul2screen_386;external;
procedure  movemul2screen_mmx;external;
procedure  movefromscreen_386;external;
procedure  movefromscreen_mmx;external;
procedure  fillbyte_386;external;
procedure  fillword_386;external;
procedure  fillword_mmx;external;
procedure  fill24_386;external;
procedure  filldword_386;external;
procedure  filldword_mmx;external;
procedure  fillpatt_8;external;
procedure  fillpatt_1516;external;
procedure  fillpatt_24;external;
procedure  fillpatt_32;external;
procedure  fillxor_1516_386;external;
procedure  fillxor_1516_mmx;external;
procedure  fillxor_24_386;external;
procedure  fillxor_32_386;external;
procedure  fillxor_32_mmx;external;
procedure  pattxor_1516;external;
procedure  pattxor_24_386;external;
procedure  pattxor_32_386;external;
procedure  pattxor_32_mmx;external;
procedure  pattadd_15;external;
procedure  pattadd_16;external;
procedure  pattadd_24_386;external;
procedure  pattadd_32_386;external;
procedure  pattadd_32_mmx;external;
procedure  pattsub_15;external;
procedure  pattsub_16;external;
procedure  pattsub_24_386;external;
procedure  pattsub_32_386;external;
procedure  pattsub_32_mmx;external;
procedure  addfill_15;external;
procedure  addfill_16;external;
procedure  addfill_24_386;external;
procedure  addfill_32_386;external;
procedure  addfill_32_mmx;external;
procedure  subfill_15;external;
procedure  subfill_16;external;
procedure  subfill_24_386;external;
procedure  subfill_32_386;external;
procedure  subfill_32_mmx;external;
procedure  calc_circle;external;
procedure  calc_ellipse;external;
procedure  randarray_byte;external;
procedure  randarray_word;external;
procedure  xor2screen_386;external;
procedure  xor2screen_mmx;external;
procedure  and2screen_386;external;
procedure  and2screen_mmx;external;
procedure  or2screen_386;external;
procedure  or2screen_mmx;external;

procedure swaplong(var i1,i2);assembler;
asm
         mov   dx,ds
         les   di,i1
         lds   si,i2
  db 66h;mov   bx,ds:[si]
  db 66h;mov   ax,es:[di]
  db 66h;mov   ds:[si],ax
  db 66h;mov   es:[di],bx
         mov   ds,dx
end;

procedure swapint(var i1,i2);assembler;
asm
  mov   dx,ds
  les   di,i1
  lds   si,i2
  mov   ax,es:[di]
  mov   bx,ds:[si]
  mov   ds:[si],ax
  mov   es:[di],bx
  mov   ds,dx
end;

procedure swapshort(var i1,i2);assembler;
asm
  mov   dx,ds
  les   di,i1
  lds   si,i2
  mov   al,es:[di]
  mov   bl,ds:[si]
  mov   ds:[si],al
  mov   es:[di],bl
  mov   ds,dx
end;

procedure swapendian32(var i);assembler;
asm
  les   di,i
  mov   ax,es:[di]
  mov   dx,es:[di+2]
  xchg  al,dh
  xchg  ah,dl
  mov   es:[di],ax
  mov   es:[di+2],dx
end;

procedure swapendian16(var i);assembler;
asm
  les   di,i
  mov   ax,es:[di]
  xchg  ah,al
  mov   es:[di],ax
end;

procedure pageretrace;assembler;
{avoids flickering when using setvisiblepage}
asm
  mov   dx,03DAh
  @lp1:
    in    al,dx
    test  al,8
  jnz   @lp1
  @lp2:
    in    al,dx
    test  al,8
  jz   @lp2
end;

procedure waitretrace;assembler;
{ waits until kathod-beam runs to the top of the screen - avoids flickering }
asm
  mov   dx,03DAh
  @lp1:
    in    al,dx
    test  al,8
  jz   @lp1
  @lp2:
    in    al,dx
    test  al,8
  jnz   @lp2
end;


function loadfont(var stream : tstream32;var font : tfont) : word;
var
  oldfm : byte;
  err   : word;
  count : longint;
begin
  loadfont := errfileerror;
  if (stream.status <> stok) then exit;
  err := errnoerror;
  if (font.id = idfont)and(font.data <> 0) then err := closefont(font);
  loadfont := err;
  if err <> errnoerror then exit;
  stream.read32(farptr(@font),sizeof(tfont));
  if (stream.status <> stok) then begin
    stream.done;
    filemode := oldfm;
    loadfont := errfalseend;
    exit;
  end;
  if (font.id <> idfont)or(font.version <> $0101) then begin
    stream.done;
    filemode := oldfm;
    loadfont := errfalseformat;
    exit;
  end;
  if (font.size > memavail32) then begin
    stream.done;
    filemode := oldfm;
    loadfont := errnomem;
    exit;
  end;
  getmem32(font.data,(font.size+15) and not 7);
  count := stream.read32(ptr48(font.data,0),font.size);
  if (count <> font.size) then begin
    stream.done;
    filemode := oldfm;
    closefont(font);
    loadfont := errfalseend;
    exit;
  end;
  font.fontstart := 0;
  loadfont := errnoerror;
  stream.done;
  filemode := oldfm;
end;

{function loadfontmem(p : pointer48;var font : tfont) : word;
begin
  move2(p,farptr(@font),sizeof(tfont));
  if (font.id <> idfont)or(font.version <> $0100) then begin
    loadfontmem := errfalseformat;
    exit;
  end;
  if font.size > memavail32 then begin
    loadfontmem := errnomem;
    exit;
  end;
  getmem32(font.data,(font.size+15) and not 7);
  move2(ptr48(seg48(p),ofs48(p)+sizeof(tfont)),ptr48(font.data,0),font.size);
  font.fontstart := 0;
  loadfontmem := errnoerror;
end;}

function savefont(var stream : tstream32;var font : tfont) : word;
var
  i    : integer;
  l    : longint;
  data : tselector;
begin
  savefont := errfileerror;
  if (stream.status <> stok) then exit;
  savefont  := errnodiskmem;
  stream.write32(farptr(@font),sizeof(tfont));
  if (stream.status <> stok) then exit;
{  if font.fontstart <> 0 then
   for l := 0 to font.startchar-font.endchar do
   decmem32l(ptr48(font.data,font.fontstart+l shl 2),font.fontstart);}
  data      := font.data;
  font.data := 0;
  stream.write32(ptr48(data,font.fontstart),font.size);
  if (stream.status <> stok) then exit;
  font.data := data;
{  if font.fontstart <> 0 then
   for l := 0 to font.startchar-font.endchar+1 do
   incmem32l(ptr48(font.data,font.fontstart+l shl 2),font.fontstart);}
  stream.done;
  savefont := errnoerror;
end;

function closefont(var font : tfont) : word;
begin
  if (font.id <> idfont)or(font.data = 0) then begin
    fillbyte(farptr(@font),sizeof(tfont),0);
    closefont := errnotopen;
    exit;
  end;
  if (font.flags and fnlocked <> 0) then begin
    closefont := errlocked;
  end else begin
    freemem32(font.data);
    fillbyte(farptr(@font),sizeof(tfont),0);
    closefont := errnoerror;
  end;
end;

function inttostr(l : longint) : string;
{ convert longint to string }
var
  c : string[20];
begin
  str(l,c);
  inttostr := c;
end;

function flttostr(l : double;f1,f2 : byte) : string;
{ convert double to string with string formatting }
var
  c : string[20];
begin
  str(l:f1:f2,c);
  flttostr := c;
end;

function hexstr(l : longint;width : word) : string;
{ Get from longint value hex-string }
const
  hexs : array[0..15] of char=
  ('0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F');
var
  s : string[10];
  i : longint;
begin
  s := '';
  for i := 0 to width-1 do
  begin
    s := hexs[l and 15]+s;
    l := l shr 4;
  end;
  hexstr := s;
end;

function hextoint(s : string) : longint;
const
  number : set of char=['0'..'9'];
var
  i    : word;
  w,w2 : longint;
begin
  w := 0;
  for i := 1 to length(s) do begin
    if s[i] in number then
    w2 := ord(s[i])-48
    else
    w2 := ord(s[i])-55;
    inc(w,w2 shl ((length(s)-i) shl 2));
  end;
  hextoint := w;
end;

function strtoint(s : string) : longint;
const
  number : set of char=['0'..'9'];
var
  code : integer;
  w    : longint;
begin
  val(s,w,code);
  if (code <> 0) then w := 0;
  strtoint := w;
end;

function getcurrentdriverinfo(var info : tdrvinfo) : boolean;
begin
  getcurrentdriverinfo := false;
  if actdrv = nil then exit;
  info := actdrv^.info;
  getcurrentdriverinfo := true;
end;

function getdriverinfo(drivernum : longint;var info : tdrvinfo) : boolean;
var
  i   : longint;
  drv : pdrvregistered;
begin
  getdriverinfo := false;
  drv := lastdrv.next;
  i := 0;
  while (i < drivernum)and(drv^.next <> nil) do
  begin
    if (drv^.detected > 0) then inc(i);
    drv := drv^.next;
  end;
  if (i = drivernum) then move(drv^.driver^.info,info,sizeof(tdrvinfo));
  getdriverinfo := (i = drivernum);
end;

function registergfxdriver(driver : pgfxdriver) : boolean;
var
  newdrv : pdrvregistered;
begin
  registergfxdriver := false;

  new(newdrv);
  newdrv^.next        := lastdrv.next;
  newdrv^.driver      := driver;
  newdrv^.detected    := driver^.proc.detect;
  lastdrv.next        := newdrv;
  if newdrv^.detected > 0 then inc(workinggfxdrivers);
  inc(registeredgfxdrivers);

  registergfxdriver   := true;
end;

procedure modetable_sort(table : pmodetable);
var
  i,i2,j : integer;
  temp   : tmoderec;
begin
  for i2 := 0 to 4 do
  for j := 0 to table^[i2].avmodes-1 do
  for i := j to table^[i2].avmodes-1 do
  begin
    if table^[i2].mode[i].resx < table^[i2].mode[j].resx then
    begin
      temp               := table^[i2].mode[i];
      table^[i2].mode[i] := table^[i2].mode[j];
      table^[i2].mode[j] := temp;
    end;
  end;
  for i2 := 0 to 4 do
  for j := 0 to table^[i2].avmodes-1 do
  for i := j to table^[i2].avmodes-1 do
  begin
    if table^[i2].mode[i].resy < table^[i2].mode[j].resy then
    begin
      temp               := table^[i2].mode[i];
      table^[i2].mode[i] := table^[i2].mode[j];
      table^[i2].mode[j] := temp;
    end;
  end;
end;

function modetable_mdauto(resx,resy : word;bpp : word;table : pmodetable) : longint;
var
  tab,i : byte;

function modeav(resx,resy,tab : word) : boolean;
var
  i : integer;
begin
  modeav := true;
  for i := 0 to table^[tab].avmodes-1 do
  with table^[tab] do
  if (mode[i].resx = resx)and(mode[i].resy = resy) then exit;
  modeav := false;
end;

begin
  modetable_mdauto := 0;
  case bpp of
    1,2,4,8    : tab := 0;
    15         : tab := 1;
    16         : tab := 2;
    24         : tab := 3;
    32         : tab := 4;
    clhi     : if modeav(resx,resy,2) then tab := 2 else tab := 1;
    cltrue   : if modeav(resx,resy,4) then tab := 4 else if
                 table^[3].avmodes <> 0 then tab := 3 else tab := 4;
    clhitrue : if modeav(resx,resy,4) then tab := 4 else
                 if modeav(resx,resy,3) then tab := 3 else
                 if modeav(resx,resy,2) then tab := 2 else tab := 1;
    clhitrueno24 : if modeav(resx,resy,4) then tab := 4 else
                   if modeav(resx,resy,2) then tab := 2 else tab := 1;
    else exit;
  end;
  for i := 0 to table^[tab].avmodes do
  with table^[tab] do
  if (mode[i].resx = resx)and(mode[i].resy = resy) then begin
    modetable_mdauto := mode[i].mode;
    exit;
  end;
end;

function modetable_mdbestfit(resx,resy : word;bpp : word;table : pmodetable) : longint;
var
  tab,i : byte;

function modeav(resx,resy,tab : word) : boolean;
var
  i : integer;
begin
  modeav := true;
  for i := 0 to table^[tab].avmodes-1 do
  with table^[tab] do
  if (mode[i].resx >= resx)and(mode[i].resy >= resy) then exit;
  modeav := false;
end;

begin
  modetable_mdbestfit := 0;
  case bpp of
    1,2,4,8    : tab := 0;
    15         : tab := 1;
    16         : tab := 2;
    24         : tab := 3;
    32         : tab := 4;
    clhi     : if modeav(resx,resy,2) then tab := 2 else tab := 1;
    cltrue   : if modeav(resx,resy,4) then tab := 4 else if
                 table^[3].avmodes <> 0 then tab := 3 else tab := 4;
    clhitrue : if modeav(resx,resy,4) then tab := 4 else
                 if modeav(resx,resy,3) then tab := 3 else
                 if modeav(resx,resy,2) then tab := 2 else tab := 1;
    clhitrueno24 : if modeav(resx,resy,4) then tab := 4 else
                   if modeav(resx,resy,2) then tab := 2 else tab := 1;
    else exit;
  end;
  for i := 0 to table^[tab].avmodes-1 do
  with table^[tab] do
  if (mode[i].resx >= resx)and(mode[i].resy >= resy) then
  begin
    modetable_mdbestfit := mode[i].mode;
    exit;
  end;
end;

function registercpuswitch(switch : pcpuswitch) : boolean;
var
  newswitch : pswitchregistered;
begin
  registercpuswitch := false;

  new(newswitch);
  newswitch^.next   := lastswitch.next;
  newswitch^.switch := switch;
  lastswitch.next   := newswitch;

  registercpuswitch := true;
end;

function setcpuext(flags : longint) : boolean;
var
  switch : pswitchregistered;
begin
  switch := lastswitch.next;
  while (switch^.next <> nil) do
  begin
    switch^.switch^(flags);
    switch := switch^.next;
  end;
end;

function getbit(value,bit : byte) : boolean;assembler;
asm
  mov   cl,bit
  mov   bl,1
  shl   bl,cl
  mov   al,value
  and   al,bl
end;

function GetRMSelector(segment : word) : word;assembler;
asm
{$ifdef dpmi}
  mov   ax,2
  mov   bx,segment
  int   31h
{$else}
  mov   ax,segment
{$endif}
end;

procedure textscreen_get;
{get and save the text screen}
begin
  with textscreen do begin
    if grabbed then exit;
    asm
      mov   ah,3
      xor   bh,bh
	    push  si
	    push  di
	    push  bp
	    push  es
	    int   10h
	    pop   es
	    pop   bp
	    pop   di
	    pop   si
      mov   byte ptr textscreen.cpos.x,dl
      mov   byte ptr textscreen.cpos.y,dh

      mov   ah,0Fh
	    push  si
	    push  di
	    push  bp
	    push  es
	    int   10h
	    pop   es
	    pop   bp
	    pop   di
	    pop   si
      mov   textscreen.mode.byte,al

      mov   ax,1130h
      xor   bh,bh
      xor   dl,dl

	    push  si
	    push  di
	    push  bp
	    push  es
	    int   10h
	    pop   es
	    pop   bp
	    pop   di
	    pop   si

      mov   textscreen.mode.byte[1],cl
    end;
    size   := memw[seg0040:$004C];
    getmem(data,size);
    move2(ptr48(segB800,0),farptr(data),size);
    grabbed := true;
  end;
end;

procedure textscreen_put;
{put the saved text screen}
begin
  with textscreen do begin
    if not grabbed then exit;
    asm
      mov   al,textscreen.mode.byte
      xor   ah,ah
      int   10h

      cmp   textscreen.mode.byte[1],8
      jne   @no8x8
        mov   ax,1112h
        xor   bl,bl
	      push  si
	      push  di
	      push  bp
	      push  es
	      int   10h
	      pop   es
	      pop   bp
	      pop   di
	      pop   si
      @no8x8:
      mov   ah,2
      xor   bh,bh
      mov   dl,byte ptr textscreen.cpos.x
      mov   dh,byte ptr textscreen.cpos.y
	    push  si
	    push  di
	    push  bp
	    push  es
	    int   10h
	    pop   es
	    pop   bp
	    pop   di
	    pop   si
    end;
    move2(farptr(data),ptr48(segB800,0),size);
    freemem(data,size);
    grabbed := false;
  end;
end;

procedure textscreen_discard;
begin
  with textscreen do begin
    if not grabbed then exit;
    freemem(data,size);
    grabbed := false;
  end;
end;

var
  i : integer;

type
	PTextBuf=^TTextBuf;
	TTextBuf=array[0..127] of Char;
	TTextRec=record
		Handle: Word;
		Mode: Word;
		BufSize: Word;
		Private: Word;
		BufPos: Word;
		BufEnd: Word;
		BufPtr: PTextBuf;
		OpenFunc: Pointer;
		InOutFunc: Pointer;
		FlushFunc: Pointer;
		CloseFunc: Pointer;
		UserData: array[1..16] of Byte;
		Name: array[0..78] of Char;
		Len: Byte;
		Buffer: TTextBuf;
	end;
  pstring = ^string;

function textwrite(var Txt: TTextRec): integer; far;
begin
	with txt do begin
		len    := bufpos;
		bufpos := 0;
    asm mov ax,3; int 10h end;
    writeln('GX2 -- application error');
		write(pstring(@len)^);
    writeln('Quitting...');
    halt;
	end;
	textwrite:=0;
end;

function textreturn(var txt : ttextrec): integer; far;
begin
	textreturn:=0;
end;

function textopen(var txt : ttextrec): integer; far;
begin
	with txt do
		if mode <> $D7B2 then
			textopen := 5 {File access denied}
		else begin
			inoutfunc := @textwrite;
			flushfunc := @textwrite;
			closefunc := @textreturn;
			textopen  := 0;
		end;
end;

var
  t      : ttextrec absolute gxerror;
  stream : pmemstream32;
begin
{  setcpuext(cpuext);}

	with t do begin
		mode     := $D7B0;
		bufsize  := sizeof(buffer);
		bufptr   := @buffer;
		openfunc := @textopen;
		name[0]  := #0;
	end;
	rewrite(gxerror);

  getmem32(gfxbufsel,gfxbufsize);
  if gfxbufsel = 0 then begin
    writeln;
    writeln('Error while allocating graphic data buffer');
    writeln('Quitting...');
    halt;
  end;
  gfxbufptr   := ptr48(gfxbufsel,0);
  gfxbufptr32 := ptr(gfxbufsel,0);
  new(stream,init(farptr(@sysfont2),3712));
  i := loadfont(stream^,fnsystem);
  if i <> 0 then begin
    writeln;
    writeln('Error while loading system font: '+errerrorstr[i and $FFF]);
    writeln('Quitting...');
    halt;
  end;
  dispose(stream);
end.