;GrafX2 image interpolators
;(c) 1998-1999 by Stefan Goehler
;detailed copyright notices in grafx2.txt
;illegal copy if without grafx2.txt

;!! = procedures or parts which are untested yet or/and have bugs or aren't
;finished yet

.model large,pascal
.386p
.data

public doublesize_24_386
public doublesize_32_386
public doublesize_32_mmx
public halfsize_24_386
public halfsize_32_386
public halfsize_32_mmx

ends

.code
include ctmmxn.inc

doublesize_24_386 proc
arg @@source: pword,@@dest: pword,@@count: dword,@@bpl: dword
           les   edi,@@dest
           mov   ecx,3
           mov   eax,@@count
           cdq
           div   ecx
           or    eax,eax
           jz    @end_ds24
           mov   @@count,eax
           mov   ecx,@@bpl
           push  ds
           lds   esi,@@source
@lp_ds24:
           mov   eax,ds:[esi]
           ;Pixel x,y
           mov   es:[edi],eax
           ;Pixel x+1,y
           mov   dx,ds:[esi+3]
           ;B
           add   dl,al
           jnc   @next_ds24_r1
             shr   dl,1
             add   dl,128
             jmp   @next2_ds24_r1
           @next_ds24_r1:
           shr   dl,1
           @next2_ds24_r1:
           ;G
           add   dh,ah
           jnc   @next_ds24_g1
             shr   dh,1
             add   dh,128
             jmp   @next2_ds24_g1
           @next_ds24_g1:
           shr   dh,1
           @next2_ds24_g1:
           mov   es:[edi+3],dx
           ;R
           mov   dx,ds:[esi+5]
           mov   ebx,eax
           shr   ebx,16
           add   dl,bl
           jnc   @next_ds24_b1
             shr   dl,1
             add   dl,128
             jmp   @next2_ds24_b1
           @next_ds24_b1:
           shr   dl,1
           @next2_ds24_b1:
           mov   es:[edi+5],dx

           ;Pixel x,y+1
           mov   dx,ds:[esi+ecx]
           ;B
           add   dl,al
           jnc   @next_ds24_r2
             shr   dl,1
             add   dl,128
             jmp   @next2_ds24_r2
           @next_ds24_r2:
           shr   dl,1
           @next2_ds24_r2:
           ;G
           add   dh,ah
           jnc   @next_ds24_g2
             shr   dh,1
             add   dh,128
             jmp   @next2_ds24_g2
           @next_ds24_g2:
           shr   dh,1
           @next2_ds24_g2:
           mov   es:[edi+ecx*2],dx
           ;R
           mov   dx,ds:[esi+ecx+2]
           add   dl,bl
           jnc   @next_ds24_b2
             shr   dl,1
             add   dl,128
             jmp   @next2_ds24_b2
           @next_ds24_b2:
           shr   dl,1
           @next2_ds24_b2:
           mov   es:[edi+ecx*2+2],dx

           ;Pixel x+1,y+1
           xor   bx,bx
           ;B
           mov   bl,al
           movzx dx,byte ptr ds:[esi+3]
           add   bx,dx
           movzx dx,byte ptr ds:[esi+ecx]
           add   bx,dx
           movzx dx,byte ptr ds:[esi+ecx+3]
           add   bx,dx
           shr   bx,2
           mov   es:[edi+ecx*2+3],bl
           ;G
           mov   bl,ah
           movzx dx,byte ptr ds:[esi+4]
           add   bx,dx
           movzx dx,byte ptr ds:[esi+ecx+1]
           add   bx,dx
           movzx dx,byte ptr ds:[esi+ecx+4]
           add   bx,dx
           shr   bx,2
           mov   es:[edi+ecx*2+4],bl
           ;R
           shr   eax,16
           mov   bl,al
           movzx dx,byte ptr ds:[esi+5]
           add   bx,dx
           movzx dx,byte ptr ds:[esi+ecx+2]
           add   bx,dx
           movzx dx,byte ptr ds:[esi+ecx+5]
           add   bx,dx
           shr   bx,2
           mov   es:[edi+ecx*2+5],bl


           add   edi,6
           add   esi,3
           dec   @@count
           jnz   @lp_ds24
           pop   ds
@end_ds24:
           ret
doublesize_24_386 endp

doublesize_32_386 proc
arg @@source: pword,@@dest: pword,@@count: dword,@@bpl: dword
           les   edi,@@dest
           shr   @@count,2
           jz    @end_ds32
           mov   ecx,@@bpl
           push  ds
           lds   esi,@@source
@lp_ds32:
           mov   eax,ds:[esi]
           ;Pixel x,y
           mov   es:[edi],eax
           ;Pixel x+1,y
           mov   dx,ds:[esi+4]
           ;B
           add   dl,al
           jnc   @next_ds_r1
             shr   dl,1
             add   dl,128
             jmp   @next2_ds_r1
           @next_ds_r1:
           shr   dl,1
           @next2_ds_r1:
           ;G
           add   dh,ah
           jnc   @next_ds_g1
             shr   dh,1
             add   dh,128
             jmp   @next2_ds_g1
           @next_ds_g1:
           shr   dh,1
           @next2_ds_g1:
           mov   es:[edi+4],dx
           ;R
           mov   dx,ds:[esi+6]
           mov   ebx,eax
           shr   ebx,16
           add   dl,bl
           jnc   @next_ds_b1
             shr   dl,1
             add   dl,128
             jmp   @next2_ds_b1
           @next_ds_b1:
           shr   dl,1
           @next2_ds_b1:
           mov   es:[edi+6],dx

           ;Pixel x,y+1
           mov   dx,ds:[esi+ecx]
           ;B
           add   dl,al
           jnc   @next_ds_r2
             shr   dl,1
             add   dl,128
             jmp   @next2_ds_r2
           @next_ds_r2:
           shr   dl,1
           @next2_ds_r2:
           ;G
           add   dh,ah
           jnc   @next_ds_g2
             shr   dh,1
             add   dh,128
             jmp   @next2_ds_g2
           @next_ds_g2:
           shr   dh,1
           @next2_ds_g2:
           mov   es:[edi+ecx*2],dx
           ;R
           mov   dx,ds:[esi+ecx+2]
           add   dl,bl
           jnc   @next_ds_b2
             shr   dl,1
             add   dl,128
             jmp   @next2_ds_b2
           @next_ds_b2:
           shr   dl,1
           @next2_ds_b2:
           mov   es:[edi+ecx*2+2],dx

           ;Pixel x+1,y+1
           xor   bx,bx
           ;B
           mov   bl,al
           movzx dx,byte ptr ds:[esi+4]
           add   bx,dx
           movzx dx,byte ptr ds:[esi+ecx]
           add   bx,dx
           movzx dx,byte ptr ds:[esi+ecx+4]
           add   bx,dx
           shr   bx,2
           mov   es:[edi+ecx*2+4],bl
           ;G
           mov   bl,ah
           movzx dx,byte ptr ds:[esi+5]
           add   bx,dx
           movzx dx,byte ptr ds:[esi+ecx+1]
           add   bx,dx
           movzx dx,byte ptr ds:[esi+ecx+5]
           add   bx,dx
           shr   bx,2
           mov   es:[edi+ecx*2+5],bl
           ;R
           shr   eax,16
           mov   bl,al
           movzx dx,byte ptr ds:[esi+6]
           add   bx,dx
           movzx dx,byte ptr ds:[esi+ecx+2]
           add   bx,dx
           movzx dx,byte ptr ds:[esi+ecx+6]
           add   bx,dx
           shr   bx,2
           mov   bh,ah                       ;possible alphachannel
           mov   es:[edi+ecx*2+6],bx


           add   edi,8
           add   esi,4
           dec   @@count
           jnz   @lp_ds32
           pop   ds
@end_ds32:
           ret
doublesize_32_386 endp

doublesize_32_mmx proc
arg @@source: pword,@@dest: pword,@@count: dword,@@bpl: dword
           les   edi,@@dest
           mov   ecx,@@count
           shr   ecx,2
           jz    @end_ds32mx
           mov   edx,@@bpl
           lgs   esi,@@source
           pxor       mm4,mm4
@lp_ds32mx:
           movq       mm0,gs:[esi],2
           movq       mm2,gs:[esi+edx],2
           movq       mm1,mm0
           movq       mm3,mm2
           punpcklbw  mm0,mm4
           punpcklbw  mm2,mm4
           punpckhbw  mm1,mm4
           punpckhbw  mm3,mm4
           movq       mm5,mm0
           movq       mm7,mm0

           paddusw    mm5,mm1
           paddusw    mm0,mm2
           movq       mm6,mm5
           psrlw      mm5,1
           paddusw    mm6,mm2
           packuswb   mm7,mm5
           paddusw    mm6,mm3
           psrlw      mm0,1
           psrlw      mm6,2
           movq       es:[edi],mm7,2
           packuswb   mm0,mm6
           movq       es:[edi+edx*2],mm0,2

           add   edi,8
           add   esi,4
           dec   ecx
           jnz   @lp_ds32mx

           movd       mm0,gs:[esi],2
           movd       mm2,gs:[esi+edx],2

           punpcklbw  mm0,mm4
           punpcklbw  mm2,mm4

           paddusw    mm0,mm2
           psrlw      mm0,1
           packuswb   mm0,mm4
           movd       es:[edi],mm0,2
           movd       es:[edi+edx*2],mm0,2

@end_ds32mx:
           emms
           ret
doublesize_32_mmx endp

halfsize_16_386 proc
arg @@source: pword,@@dest: pword,@@sizex: dword,@@bpl: dword
           cmp   @@count,0
           jz    @end_hs16
           mov   ecx,@@bpl
           push  ds
           les   edi,@@dest
           lds   esi,@@source
           xor   eax,eax
           xor   ebx,ebx
           xor   edx,edx
@lp_hs16:
           mov   al,ds:[esi]
           mov   dl,ds:[esi+4]
           mov   bl,ds:[esi+ecx]
           add   ax,dx
           mov   dl,ds:[esi+ecx+4]
           add   ax,bx
           add   ax,dx
           shr   ax,2
           mov   es:[edi],al

           mov   al,ds:[esi+1]
           mov   dl,ds:[esi+5]
           mov   bl,ds:[esi+ecx+1]
           add   ax,dx
           mov   dl,ds:[esi+ecx+5]
           add   ax,bx
           add   ax,dx
           shr   ax,2
           mov   es:[edi+1],al

           mov   al,ds:[esi+2]
           mov   dl,ds:[esi+6]
           mov   bl,ds:[esi+ecx+2]
           add   ax,dx
           mov   dl,ds:[esi+ecx+6]
           add   ax,bx
           add   ax,dx
           shr   ax,2

           mov   ah,ds:[esi+3]
           add   esi,8
           mov   es:[edi+2],ax
           xor   ax,ax

           add   edi,4
           dec   @@count
           jnz   @lp_hs16
           pop   ds
@end_hs16:
           ret
halfsize_16_386 endp

halfsize_24_386 proc
arg @@source: pword,@@dest: pword,@@sizex: dword,@@bpl: dword
           cmp   @@count,0
           jz    @end_hs24
           mov   ecx,@@bpl
           push  ds
           les   edi,@@dest
           lds   esi,@@source
           xor   eax,eax
           xor   ebx,ebx
           xor   edx,edx
@lp_hs24:
           mov   al,ds:[esi]
           mov   dl,ds:[esi+3]
           mov   bl,ds:[esi+ecx]
           add   ax,dx
           mov   dl,ds:[esi+ecx+3]
           add   ax,bx
           add   ax,dx
           shr   ax,2
           mov   es:[edi],al

           mov   al,ds:[esi+1]
           mov   dl,ds:[esi+4]
           mov   bl,ds:[esi+ecx+1]
           add   ax,dx
           mov   dl,ds:[esi+ecx+4]
           add   ax,bx
           add   ax,dx
           shr   ax,2
           mov   es:[edi+1],al

           mov   al,ds:[esi+2]
           mov   dl,ds:[esi+5]
           mov   bl,ds:[esi+ecx+2]
           add   ax,dx
           mov   dl,ds:[esi+ecx+5]
           add   ax,bx
           add   ax,dx
           shr   ax,2
           mov   es:[edi+2],al

           mov   al,ds:[esi+3]
           add   esi,6
           mov   es:[edi+3],al

           add   edi,3
           dec   @@count
           jnz   @lp_hs24
           pop   ds
@end_hs24:
           ret
halfsize_24_386 endp

halfsize_32_386 proc
arg @@source: pword,@@dest: pword,@@sizex: dword,@@bpl: dword
           cmp   @@count,0
           jz    @end_hs32
           mov   ecx,@@bpl
           push  ds
           les   edi,@@dest
           lds   esi,@@source
           xor   eax,eax
           xor   ebx,ebx
           xor   edx,edx
@lp_hs32:
           mov   al,ds:[esi]
           mov   dl,ds:[esi+4]
           mov   bl,ds:[esi+ecx]
           add   ax,dx
           mov   dl,ds:[esi+ecx+4]
           add   ax,bx
           add   ax,dx
           shr   ax,2
           mov   es:[edi],al

           mov   al,ds:[esi+1]
           mov   dl,ds:[esi+5]
           mov   bl,ds:[esi+ecx+1]
           add   ax,dx
           mov   dl,ds:[esi+ecx+5]
           add   ax,bx
           add   ax,dx
           shr   ax,2
           mov   es:[edi+1],al

           mov   al,ds:[esi+2]
           mov   dl,ds:[esi+6]
           mov   bl,ds:[esi+ecx+2]
           add   ax,dx
           mov   dl,ds:[esi+ecx+6]
           add   ax,bx
           add   ax,dx
           shr   ax,2

           mov   ah,ds:[esi+3]
           add   esi,8
           mov   es:[edi+2],ax
           xor   ax,ax

           add   edi,4
           dec   @@count
           jnz   @lp_hs32
           pop   ds
@end_hs32:
           ret
halfsize_32_386 endp

halfsize_32_mmx proc
arg @@source: pword,@@dest: pword,@@count: dword,@@bpl: dword
           mov   ecx,@@count
           mov   ebx,ecx
           shr   ecx,1
           jz    @end_hs32mx
           mov   edx,@@bpl
           lgs   esi,@@dest
           les   edi,@@source
           pxor  mm4,mm4
@lp_hs32mx:
           movq       mm0,es:[edi],2
           movq       mm5,es:[edi+8],2
           movq       mm2,es:[edi+edx],2
           movq       mm6,es:[edi+edx+8],2
           movq       mm1,mm0
           punpcklbw  mm0,mm4
           punpckhbw  mm1,mm4
           movq       mm3,mm2
           paddusw    mm0,mm1
           punpcklbw  mm2,mm4
           punpckhbw  mm3,mm4
           paddusw    mm0,mm2
           paddusw    mm0,mm3
           psrlw      mm0,2

           movq       mm1,mm5
           punpcklbw  mm5,mm4
           punpckhbw  mm1,mm4
           movq       mm3,mm6
           paddusw    mm5,mm1
           punpcklbw  mm6,mm4
           punpckhbw  mm3,mm4
           paddusw    mm5,mm6
           paddusw    mm5,mm3
           psrlw      mm5,2
           packuswb   mm0,mm5
           movq       gs:[esi],mm0,2

           add   esi,8
           add   edi,16
           dec   ecx
           jnz   @lp_hs32mx

           test  ebx,1
           jz    @end_hs32mx
           movq       mm0,gs:[esi],2
           movq       mm2,gs:[esi+edx],2
           movq       mm1,mm0
           punpcklbw  mm0,mm4
           punpckhbw  mm1,mm4
           movq       mm3,mm2
           paddusw    mm0,mm1
           punpcklbw  mm2,mm4
           punpckhbw  mm3,mm4
           paddusw    mm0,mm2
           paddusw    mm0,mm3
           psrlw      mm0,2
           movd       es:[edi],mm0,2
@end_hs32mx:
           emms
           ret
halfsize_32_mmx endp

ends
end
